Difference between revisions of "Mesh Scripting"

From FreeCAD Documentation
Jump to navigation Jump to search
(Fix typos)
(Removed Docnav.)
 
(65 intermediate revisions by 16 users not shown)
Line 1: Line 1:
=== Introduction ===
+
<languages/>
 +
<translate>
  
First of all you have to import the Mesh module:
+
</translate>
import Mesh
+
{{TOCright}}
After that you have access to the Mesh module and the Mesh class which facilitate the functions
+
<translate>
of the FreeCAD C++ Mesh-Kernel.
 
  
=== Creation and Loading ===  
+
==Introduction== <!--T:1-->
  
 +
<!--T:25-->
 +
To get access to the {{incode|Mesh}} module you have to import it first:
 +
 +
</translate>
 +
{{Code|code=
 +
import Mesh
 +
}}
 +
<translate>
 +
 +
==Creation== <!--T:3-->
 +
 +
<!--T:32-->
 
To create an empty mesh object just use the standard constructor:
 
To create an empty mesh object just use the standard constructor:
mesh = Mesh.Mesh()
 
You can also create an object from a file
 
mesh = Mesh.Mesh('D:/temp/Something.stl')
 
What file formats you can use to build up a mesh is noted [[Feature_list#IO|here]].
 
  
 +
</translate>
 +
{{Code|code=
 +
mesh = Mesh.Mesh()
 +
}}
 +
<translate>
 +
 +
<!--T:4-->
 +
You can also create an object from a file:
 +
 +
</translate>
 +
{{Code|code=
 +
mesh = Mesh.Mesh("D:/temp/Something.stl")
 +
}}
 +
<translate>
 +
 +
<!--T:6-->
 
Or create it out of a set of triangles described by their corner points:
 
Or create it out of a set of triangles described by their corner points:
  
planarMesh = [
+
</translate>
# triangle 1
+
{{Code|code=
[-0.5000,-0.5000,0.0000],[0.5000,0.5000,0.0000],[-0.5000,0.5000,0.0000],
+
triangles = [
#triangle 2
+
# triangle 1
[-0.5000,-0.5000,0.0000],[0.5000,-0.5000,0.0000],[0.5000,0.5000,0.0000],
+
[-0.5000, -0.5000, 0.0000], [0.5000, 0.5000, 0.0000], [-0.5000, 0.5000, 0.0000],
]
+
#triangle 2
planarMeshObject = Mesh.Mesh(planarMesh)
+
[-0.5000, -0.5000, 0.0000], [0.5000, -0.5000, 0.0000], [0.5000, 0.5000, 0.0000],
 +
]
 +
meshObject = Mesh.Mesh(triangles)
 +
Mesh.show(meshObject)
 +
}}
 +
<translate>
 +
 
 +
<!--T:7-->
 +
The Mesh-Kernel takes care of creating a topologically correct data structure by sorting coincident points and edges.
 +
 
 +
<!--T:28-->
 +
[[#top|top]]
  
The Mesh-Kernel takes care about creating a topological correct data structure by sorting
+
==Modeling== <!--T:9-->
coincident points and edges together.
 
  
Later on you will see how you can test and examine mesh data.
+
<!--T:26-->
 +
To create regular geometries you can use one of the {{incode|create*()}} methods. A torus, for instance, can be created as follows:
  
=== Modeling ===
+
</translate>
 +
{{Code|code=
 +
m = Mesh.createTorus(8.0, 2.0, 50)
 +
Mesh.show(m)
 +
}}
 +
<translate>
  
To create regular geometries you can use the Python script BuildRegularGeoms.py.
+
<!--T:11-->
import BuildRegularGeoms
+
The first two parameters define the radii of the torus and the third parameter is a sub-sampling factor for how many triangles are created. The higher this value the smoother the mesh.
This script provides methods to define simple rotation bodies like spheres, ellipsoids, cylinders, toroids and cones. And it also has a method to create a simple cube.
 
To create a toroid, for instance, can be done as follows:
 
t = BuildRegularGeoms.Toroid(8.0, 2.0, 50) # list with several thousands triangles
 
m = Mesh.Mesh(t)
 
  
The first two parameters define the radiuses of the toroid and the third parameter is a sub-sampling factor for how many triangles are created. The higher this value the smoother and the lower the coarser the body is.
+
<!--T:33-->
The Mesh class provides a set of boolean functions that can be used for modeling purposes. It provides union, intersection and difference of two mesh objects.
+
The {{incode|Mesh}} module also provides three Boolean methods: {{incode|union()}}, {{incode|intersection()}} and {{incode|difference()}}:
m1, m2              # are the input mesh objects
 
m3 = Mesh.Mesh(m1)  # create a copy of m1
 
m3.unite(m2)       # union of m1 and m2, the result is stored in m3
 
m4 = Mesh.Mesh(m1)
 
m4.intersect(m2)    # intersection of m1 and m2
 
m5 = Mesh.Mesh(m1)
 
m5.difference(m2)  # the difference of m1 and m2
 
m6 = Mesh.Mesh(m2)
 
m6.difference(m1)   # the difference of m2 and m1, usually the result is different to m5
 
Finally, a full example that computes the intersection between a sphere and a cylinder that intersects the sphere.
 
import Mesh, BuildRegularGeoms
 
sphere = Mesh.Mesh( BuildRegularGeoms.Sphere(5.0, 50) )
 
cylinder = Mesh.Mesh( BuildRegularGeoms.Cylinder(2.0, 10.0, True, 1.0, 50) )
 
diff = sphere
 
diff.difference(cylinder)
 
d = FreeCAD.newDocument()
 
d.addObject("Mesh::Feature","Diff_Sphere_Cylinder").Mesh=diff
 
d.recompute()
 
  
=== Examining and Testing ===  
+
</translate>
 +
{{Code|code=
 +
m1, m2              # are the input mesh objects
 +
m3 = Mesh.Mesh(m1)  # create a copy of m1
 +
m3.unite(m2)        # union of m1 and m2, the result is stored in m3
 +
m4 = Mesh.Mesh(m1)
 +
m4.intersect(m2)    # intersection of m1 and m2
 +
m5 = Mesh.Mesh(m1)
 +
m5.difference(m2)  # the difference of m1 and m2
 +
m6 = Mesh.Mesh(m2)
 +
m6.difference(m1)  # the difference of m2 and m1, usually the result is different to m5
 +
}}
 +
<translate>
  
=== Write your own Algorithms ===
+
<!--T:12-->
 +
Here is an example that creates a pipe using the {{incode|difference()}} method:
  
=== Exporting ===  
+
</translate>
 +
{{Code|code=
 +
import FreeCAD, Mesh
 +
cylA = Mesh.createCylinder(2.0, 10.0, True, 1.0, 36)
 +
cylB = Mesh.createCylinder(1.0, 12.0, True, 1.0, 36)
 +
cylB.Placement.Base = (FreeCAD.Vector(-1, 0, 0)) # move cylB to avoid co-planar faces
 +
pipe = cylA
 +
pipe = pipe.difference(cylB)
 +
pipe.flipNormals() # somehow required
 +
doc = FreeCAD.ActiveDocument
 +
obj = d.addObject("Mesh::Feature", "Pipe")
 +
obj.Mesh = pipe
 +
doc.recompute()
 +
}}
 +
<translate>
  
You can even write the mesh to a python module:
+
<!--T:29-->
m.write("D:/Develop/Projekte/FreeCAD/FreeCAD_0.7/Mod/Mesh/SavedMesh.py")
+
[[#top|top]]
import SavedMesh
 
m2 = Mesh.Mesh(SavedMesh.faces)
 
  
=== Gui related stuff ===  
+
==Notes== <!--T:17-->
  
=== Odds and Ends ===
+
<!--T:27-->
An extensive, ought hard to use, source of Mesh related scripting are the unit test scripts of the Mesh-Module.  
+
An extensive, though hard to use, source of mesh related scripting are the unit test scripts of the {{incode|Mesh}} module.  
In this unit tests literally all methods are called and all properties/attributes are tweaked.
+
In these unit tests literally all methods are called and all properties/attributes are tweaked.
So if you are bold enough, take a look at the [http://free-cad.svn.sourceforge.net/viewvc/free-cad/trunk/src/Mod/Mesh/App/MeshTestsApp.py?view=markup Unit Test module].
+
So if you are bold enough, take a look at the [https://github.com/FreeCAD/FreeCAD/blob/master/src/Mod/Mesh/App/MeshTestsApp.py Unit Test module].
  
{{docnav|FreeCAD Scripting Basics|Topological data scripting}}
+
<!--T:20-->
 +
See also: [[Mesh_API|Mesh API]].
  
{{languages | {{es|Mesh Scripting/es}} {{se|Mesh Scripting/se}} {{ru|Mesh Scripting/ru}} }}
+
<!--T:31-->
 +
[[#top|top]]
  
[[Category:Poweruser Documentation]]
+
</translate>
 +
{{Powerdocnavi{{#translation:}}}}
 +
[[Category:Developer Documentation{{#translation:}}]]
 +
[[Category:Python Code{{#translation:}}]]
 +
{{Mesh Tools navi{{#translation:}}}}
 +
{{clear}}

Latest revision as of 14:28, 20 August 2020

Other languages:
Bahasa Indonesia • ‎Deutsch • ‎English • ‎Türkçe • ‎español • ‎français • ‎italiano • ‎polski • ‎română • ‎svenska • ‎čeština • ‎русский • ‎中文(中国大陆)‎

Introduction

To get access to the Mesh module you have to import it first:

import Mesh

Creation

To create an empty mesh object just use the standard constructor:

mesh = Mesh.Mesh()

You can also create an object from a file:

mesh = Mesh.Mesh("D:/temp/Something.stl")

Or create it out of a set of triangles described by their corner points:

triangles = [
# triangle 1
[-0.5000, -0.5000, 0.0000], [0.5000, 0.5000, 0.0000], [-0.5000, 0.5000, 0.0000],
#triangle 2
[-0.5000, -0.5000, 0.0000], [0.5000, -0.5000, 0.0000], [0.5000, 0.5000, 0.0000],
]
meshObject = Mesh.Mesh(triangles)
Mesh.show(meshObject)

The Mesh-Kernel takes care of creating a topologically correct data structure by sorting coincident points and edges.

top

Modeling

To create regular geometries you can use one of the create*() methods. A torus, for instance, can be created as follows:

m = Mesh.createTorus(8.0, 2.0, 50)
Mesh.show(m)

The first two parameters define the radii of the torus and the third parameter is a sub-sampling factor for how many triangles are created. The higher this value the smoother the mesh.

The Mesh module also provides three Boolean methods: union(), intersection() and difference():

m1, m2              # are the input mesh objects
m3 = Mesh.Mesh(m1)  # create a copy of m1
m3.unite(m2)        # union of m1 and m2, the result is stored in m3
m4 = Mesh.Mesh(m1)
m4.intersect(m2)    # intersection of m1 and m2
m5 = Mesh.Mesh(m1)
m5.difference(m2)   # the difference of m1 and m2
m6 = Mesh.Mesh(m2)
m6.difference(m1)   # the difference of m2 and m1, usually the result is different to m5

Here is an example that creates a pipe using the difference() method:

import FreeCAD, Mesh
cylA = Mesh.createCylinder(2.0, 10.0, True, 1.0, 36)
cylB = Mesh.createCylinder(1.0, 12.0, True, 1.0, 36)
cylB.Placement.Base = (FreeCAD.Vector(-1, 0, 0)) # move cylB to avoid co-planar faces
pipe = cylA
pipe = pipe.difference(cylB)
pipe.flipNormals() # somehow required
doc = FreeCAD.ActiveDocument
obj = d.addObject("Mesh::Feature", "Pipe")
obj.Mesh = pipe
doc.recompute()

top

Notes

An extensive, though hard to use, source of mesh related scripting are the unit test scripts of the Mesh module. In these unit tests literally all methods are called and all properties/attributes are tweaked. So if you are bold enough, take a look at the Unit Test module.

See also: Mesh API.

top